-- Additional lights made by AR162b for BeamNG.Drive

local M = {}


local lightsPDState = 0
local ToggledPD = false
local ToggledAlley = false
local ToggledTaxi = false
local PDlights = 0
local blinkPDTimerThreshold = 0.4
local blinkPDTimerThresholdHalf = 0
local blinkPDTimer = 0
local blinkPDTimerShort = 0
local blinkPDTimerMode = 0
local blinkshorttime = 0.07
local TaxiLight = 0
local BlinkSignalTimerShort = 0
local BlinkSignalShortTime = 0.1
local blinkSignal1 = 0
local blinkSignal2 = 0
local blinkSignal3 = 0
local blinkSignal4 = 0
local blinkSignal5 = 0
local blinkSignal6 = 0
local blinkSignal7 = 0
local blinkSignal8 = 0
local blinkPDModeA = 0
local blinkPDModeB = 1
local PDW = 0
local blinkPDTimer = 0
local blinkPDPulseLeft = 0
local blinkPDPulseRight = 0
local blinkPDPulseShortLeft = 0
local blinkPDPulseShortRight = 0

local function onInit()
	electrics.values['alley_steer'] = 0
	electrics.values['alley_steerR'] = 0
	electrics.values['PD_R'] = 0
	electrics.values['PD_L'] = 0
	electrics.values['PD_short_R'] = 0
	electrics.values['PD_short_L'] = 0
	electrics.values['PDa'] = 0
	electrics.values['PDB'] = 0

	electrics.values['taxisign'] = 0
	electrics.values['taxiOD'] = 0

	electrics.values['spinmerightroundbaby'] = 1
	electrics.values['spinmeleftroundbaby'] = 1
	electrics.values['blinkSignalShort1'] = 0
	electrics.values['blinkSignalShort2'] = 0
	electrics.values['blinkSignalShort3'] = 0
	electrics.values['blinkSignalShort4'] = 0
	electrics.values['blinkSignalShort5'] = 0
	electrics.values['blinkSignalShort6'] = 0
	electrics.values['blinkSignalShort7'] = 0
	electrics.values['blinkSignalShort8'] = 0
	electrics.values['blinkHazardShortL'] = 0
	electrics.values['blinkHazardShortR'] = 0
end

local function reset()
	onInit()
end


local function generateBlinkPDTimer(dt)

    blinkPDTimerThresholdHalf = (blinkPDTimerThreshold / 2)

    blinkPDTimer = blinkPDTimer + (dt)

    if blinkPDTimer > blinkPDTimerThreshold then
        blinkPDTimer = blinkPDTimer - blinkPDTimerThreshold
	blinkPDPulseLeft = 0
	blinkPDPulseRight = 1
	else
    if blinkPDTimer > blinkPDTimerThresholdHalf then
	blinkPDPulseLeft = 1
	blinkPDPulseRight = 0
	end
    end
end

local function generateBlinkPDTimerMode(dt)

    blinkPDTimerMode = blinkPDTimerMode + (dt)

    if blinkPDTimerMode > 7 then
        blinkPDTimerMode = blinkPDTimerMode - 7
	blinkPDModeA = 0
	blinkPDModeB = 1
	else
    if blinkPDTimerMode > 5 then
	blinkPDModeA = 1
	blinkPDModeB = 0
	end
    end
end

local function generateBlinkPDTimerShort(dt)

    blinkPDTimerShort = blinkPDTimerShort + (dt)

    if blinkPDTimerShort > (8*blinkshorttime) then
	blinkPDTimerShort = 0
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 1

    else
    if blinkPDTimerShort > (7*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (6*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 1

    else
    if blinkPDTimerShort > (5*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (4*blinkshorttime) then
	blinkPDPulseShortLeft = 1
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (3*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (2*blinkshorttime) then
	blinkPDPulseShortLeft = 1
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (1*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    end
    end
    end
    end
    end
    end
    end
    end
end

local function generateBlinkSignalTimerShort(dt)

    BlinkSignalTimerShort = BlinkSignalTimerShort + (dt)

    if BlinkSignalTimerShort > (11*BlinkSignalShortTime) then
	BlinkSignalTimerShort = 0
	blinkSignal1 = 1
	blinkSignal2 = 1
	blinkSignal3 = 1
	blinkSignal4 = 1
	blinkSignal5 = 1
	blinkSignal6 = 1
	blinkSignal7 = 1
	blinkSignal8 = 1

    else
	if BlinkSignalTimerShort > (10*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 1
	blinkSignal3 = 1
	blinkSignal4 = 1
	blinkSignal5 = 1
	blinkSignal6 = 1
	blinkSignal7 = 1
	blinkSignal8 = 1
    else
    if BlinkSignalTimerShort > (9*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 0
	blinkSignal3 = 1
	blinkSignal4 = 1
	blinkSignal5 = 1
	blinkSignal6 = 1
	blinkSignal7 = 1
	blinkSignal8 = 1
    else
    if BlinkSignalTimerShort > (8*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 0
	blinkSignal3 = 0
	blinkSignal4 = 1
	blinkSignal5 = 1
	blinkSignal6 = 1
	blinkSignal7 = 1
	blinkSignal8 = 1
    else
    if BlinkSignalTimerShort > (7*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 0
	blinkSignal3 = 0
	blinkSignal4 = 0
	blinkSignal5 = 1
	blinkSignal6 = 1
	blinkSignal7 = 1
	blinkSignal8 = 1
    else
    if BlinkSignalTimerShort > (6*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 0
	blinkSignal3 = 0
	blinkSignal4 = 0
	blinkSignal5 = 0
	blinkSignal6 = 1
	blinkSignal7 = 1
	blinkSignal8 = 1
    else
    if BlinkSignalTimerShort > (5*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 0
	blinkSignal3 = 0
	blinkSignal4 = 0
	blinkSignal5 = 0
	blinkSignal6 = 0
	blinkSignal7 = 1
	blinkSignal8 = 1
    else
    if BlinkSignalTimerShort > (4*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 0
	blinkSignal3 = 0
	blinkSignal4 = 0
	blinkSignal5 = 0
	blinkSignal6 = 0
	blinkSignal7 = 0
	blinkSignal8 = 1
    else
    if BlinkSignalTimerShort > (3*BlinkSignalShortTime) then
	blinkSignal1 = 0
	blinkSignal2 = 0
	blinkSignal3 = 0
	blinkSignal4 = 0
	blinkSignal5 = 0
	blinkSignal6 = 0
	blinkSignal7 = 0
	blinkSignal8 = 0

	--end
    end
    end
    end
    end
    end
    end
    end
    end
    end
end

local function updateGFX(dt)
    generateBlinkPDTimer(dt)
    generateBlinkPDTimerShort(dt)	
    generateBlinkPDTimerMode(dt)
    generateBlinkSignalTimerShort(dt)
	
    local vals = M.values



	if input.keys['F'] then
		--blinkPDTimer = blinkPDTimer - blinkPDTimer
    		BlinkSignalTimerShort = BlinkSignalTimerShort - BlinkSignalTimerShort
		if not ToggledPD then
			ToggledPD = true
			if PDlights == 3 then
				gui.message("Police and Warning Lights Disabled")
				PDlights = 0
				electrics.values['PDB'] = 0
				PDW = 0
		
			else
				if PDlights == 0 then
				gui.message("Police Lights Enabled")				
				PDlights = PDlights + 1
				electrics.values['PDB'] = 1
				PDW = 0

			else
				if PDlights == 1 then
				gui.message("Police and Warning Lights Enabled ")
				PDlights = PDlights + 1				
				electrics.values['PDB'] = 1
				PDW = 1
			else
				if PDlights == 2 then
				gui.message("Warning Lights Enabled")
				PDlights = PDlights + 1				
				electrics.values['PDB'] = 0
				PDW = 1
			end
			end
			end
			end
		end
	else
		ToggledPD = false
	end

	if input.keys['G'] then
		if not ToggledAlley then
			ToggledAlley = true
			if electrics.values['PDa'] == 1 then
				gui.message("Alley Lights Disabled")

				electrics.values['PDa'] = 0
		
			else
				gui.message("Alley Lights Enabled")				

				electrics.values['PDa'] = 1
		
			end
		end
	else
		ToggledAlley = false
	end

	if input.keys['T'] then
		if not ToggledTaxi then
			ToggledTaxi = true
			if TaxiLight == 2 then
				gui.message("Taxi Lights off")
				electrics.values['taxisign'] = 0
				electrics.values['taxiOD'] = 0
				TaxiLight = 0
		
			else
				if TaxiLight == 1 then
				gui.message("Taxi Lights Off-Duty")
				electrics.values['taxisign'] = 0
				electrics.values['taxiOD'] = 1
				TaxiLight = TaxiLight + 1
				
				else
				gui.message("Taxi Lights on")
				electrics.values['taxisign'] = 1
				electrics.values['taxiOD'] = 0
				TaxiLight = TaxiLight + 1

				end
			end
		end
	else
		ToggledTaxi = false
	end

    	electrics.values['PD_R'] = (electrics.values['PDB']  * ((blinkPDPulseRight * blinkPDModeB) + (blinkPDPulseLeft * blinkPDModeA)))
    	electrics.values['PD_L'] = (electrics.values['PDB']  * blinkPDPulseLeft)
    	electrics.values['PD_short_R'] = (electrics.values['PDB']  * blinkPDPulseShortRight)
    	electrics.values['PD_short_L'] = (electrics.values['PDB']  * blinkPDPulseShortLeft)
	electrics.values['spinmerightroundbaby'] = ((electrics.values['spinmerightroundbaby'] +  (dt * 100)) % 360) * electrics.values['PDB'] 
    	electrics.values['spinmeleftroundbaby'] = ((electrics.values['spinmeleftroundbaby'] -  (dt * 100)) % 360) * electrics.values['PDB'] 
	electrics.values['alley_steer'] = ((((electrics.values['steering']) * (electrics.values['PDa']))/(v.data.input.steeringWheelLock)) - (1-electrics.values['PDa']))
	electrics.values['alley_steerR'] = ((((electrics.values['steering']) * (electrics.values['PDa']))/(v.data.input.steeringWheelLock)) + (1-electrics.values['PDa']))

	electrics.values['blinkSignalShort1'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal8)*electrics.values['signal_right_input']+(blinkSignal1)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseRight))
	electrics.values['blinkSignalShort2'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal7)*electrics.values['signal_right_input']+(blinkSignal2)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseRight))
	electrics.values['blinkSignalShort3'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal6)*electrics.values['signal_right_input']+(blinkSignal3)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseLeft))
	electrics.values['blinkSignalShort4'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal5)*electrics.values['signal_right_input']+(blinkSignal4)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseLeft))
	electrics.values['blinkSignalShort5'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal4)*electrics.values['signal_right_input']+(blinkSignal5)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseLeft))
	electrics.values['blinkSignalShort6'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal3)*electrics.values['signal_right_input']+(blinkSignal6)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseLeft))
	electrics.values['blinkSignalShort7'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal2)*electrics.values['signal_right_input']+(blinkSignal7)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseRight))
	electrics.values['blinkSignalShort8'] = PDW *((1-(electrics.values['signal_right_input']*electrics.values['signal_left_input']))*((blinkSignal1)*electrics.values['signal_right_input']+(blinkSignal8)*electrics.values['signal_left_input'])+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*blinkPDPulseRight))
	
	electrics.values['blinkHazardShortL'] = PDW * blinkPDPulseShortLeft*(((electrics.values['signal_right_input']*electrics.values['signal_left_input'])+electrics.values['signal_right_input']+electrics.values['signal_left_input'])/(1+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*2)))
	electrics.values['blinkHazardShortR'] = PDW * blinkPDPulseShortRight*(((electrics.values['signal_right_input']*electrics.values['signal_left_input'])+electrics.values['signal_right_input']+electrics.values['signal_left_input'])/(1+(electrics.values['signal_right_input']*electrics.values['signal_left_input']*2)))
end

 


-- public interface
M.Reset       = Reset
M.onInit	= onInit
M.updateGFX   = updateGFX
M.generateBlinkPDTimer = generateBlinkPDTimer

return M